unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    rhoEdit: TLabeledEdit;
    sumEdit: TLabeledEdit;
    KcalcBtn: TBitBtn;
    kEdit: TLabeledEdit;
    CdEdit: TLabeledEdit;
    GroupBox2: TGroupBox;
    mEdit: TLabeledEdit;
    gEdit: TLabeledEdit;
    vhBtn: TBitBtn;
    Memo1: TMemo;
    Chart1: TChart;
    Series1: TLineSeries;
    jEdit: TLabeledEdit;
    Series2: TLineSeries;
    GroupBox3: TGroupBox;
    sum2Edit: TLabeledEdit;
    k2Edit: TLabeledEdit;
    cd2Edit: TLabeledEdit;
    kcalc2Btn: TBitBtn;
    tBEdit: TLabeledEdit;
    CheckBox1: TCheckBox;
    Series3: TPointSeries;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Series4: TPointSeries;
    procedure KcalcBtnClick(Sender: TObject);
    procedure vhBtnClick(Sender: TObject);
    procedure kcalc2BtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    procedure downN(tB, k, kb, m, g: extended; j: integer);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// pV[gCR͌WCRvZkg/mvZ
// pV[gJ̑\ʐςŁAJr
// ʐς́A~vZ̒sinJ[uŌvZ܂B
procedure TForm1.kcalc2BtnClick(Sender: TObject);
var
  kp : extended;    // CRW  kg/m
  Cdp: extended;    // CR͌W
  r  : extended;    // Cx   kg/m^3
  Sp : extended;    // \ʐ   m^2
  ch : integer;
begin
  val(Cd2Edit.Text, Cdp, ch);
  if ch <> 0 then begin
    Memo1.Text := 'Cdp:CR͌WɊԈႢ܂B';
    exit;
  end;
  val(rhoEdit.Text, r, ch);
  if ch <> 0 then begin
    Memo1.Text := ':CxɊԈႢ܂B';
    exit;
  end;
  val(sum2Edit.Text, Sp, ch);
  if ch <> 0 then begin
    Memo1.Text := 'Sp:\ʐςɊԈႢ܂B';
    exit;
  end;
  kp := Cdp * r * sp / 2;
  k2Edit.Text := floatTostr(kp);
end;

// _Co[CR͌WCRvZkg/mvZ
// pV[gJƃ_Co[̎pς
// \ʐςς͍̂lȂ
// pV[gJ́A_Co[̋CR
// vZwǉeȂ
procedure TForm1.KcalcBtnClick(Sender: TObject);
var
  k   : extended;   // CRW  kg/m
  Cd  : extended;   // CR͌W
  r   : extended;   // Cx   kg/m^3
  S   : extended;   // \ʐ   m^2
  ch  : integer;
begin
  val(CdEdit.Text, Cd, ch);
  if ch <> 0 then begin
    Memo1.Text := 'Cd:CR͌WɊԈႢ܂B';
    exit;
  end;
  val(rhoEdit.Text, r, ch);
  if ch <> 0 then begin
    Memo1.Text := ':CxɊԈႢ܂B';
    exit;
  end;
  val(sumEdit.Text, S, ch);
  if ch <> 0 then begin
    Memo1.Text := 'S:\ʐςɊԈႢ܂B';
    exit;
  end;
  k := Cd * r * s / 2;
  kEdit.Text := floatTostr(k);
end;

// ~ ̌vZ͂Ȃ
// pV[gsinJ[uŊĴƂČvZ
// _Co[̎pω͍l
// tB:                    sec
// k:    g̕ CRW  kg/m
// kb:   pV[g@CRW  kg/m
// m:    g̕׏d(d)     kg
// g:    d͉x           m/s^2
procedure TForm1.downN(tB, k, KB, m, g: extended; j: integer);
var
  vmax, ti : extended;
  h, v: extended;
  hb, vb: extended;
  dv, dm, dt, mdg, fv : extended;
  ndv, nmdg : extended;
  i, n : integer;
  mkB : extended;
  maxmdg : extended;
  dq, sq : extended;
  Qs2 : extended;
  kf : extended;
begin
  series1.Clear;
  series2.Clear;
  series3.Clear;
  series4.Clear;
  Chart1.RightAxis.AutomaticMaximum := True;
  case radiogroup1.ItemIndex of
    0:  begin
          Chart1.LeftAxis.Title.Text := 'G';
          Chart1.RightAxis.Title.Text := 'm';
        end;
    1:  begin
          Chart1.LeftAxis.Title.Text := 'G';
          Chart1.RightAxis.Title.Text := 'm/s';
          Chart1.RightAxis.AutomaticMaximum := False;
          Chart1.RightAxis.Maximum := 0;
        end;
    2:  begin
          Chart1.LeftAxis.Title.Text := 'kg/m';
          Chart1.RightAxis.Title.Text := 'm';
        end;
    3:  begin
          Chart1.LeftAxis.Title.Text := 'G';
          Chart1.RightAxis.Title.Text := 'm';
        end;
    4:  begin
          Chart1.LeftAxis.Title.Text := 'G';
          Chart1.RightAxis.Title.Text := '';
        end;
  end;
  n := j div 10;
  h := 0;                           //  or    m
  hb := h;
  dt := tb / j;                     // t
  fv := 0;                          // x           m/s
  vmax := sqrt(m * g / k);          // tx        m/s
  v := vmax;
  vb := v;                          // x@@@@
  maxmdg := 0;                      // őx
  Qs2 := - pi / 2;                  // sin@Jnpx@rad
  dq := pi / j;                     // px         rad
  sq := 0;
  for i := 0 to j + n do begin
    ti := i * dt;
    if i <= J then begin
      sq := (1 + sin(Qs2 + dq * i)) / 2;  // Q pV[g̊JWsin(-pi/2`pi/2)
      if checkbox1.Checked = true then
        mkb := k + kB * sq * sq           // CRW sin(Q)^2C
      else
        mkb := k + kB * sq;               // CRW sin(Q)C
    end
    else
      mkb := k + kB;
    vmax := sqrt(m * g / mkb);      // tx        m/s
    dm := vmax * vmax * mkb;        // tR        m.kg/s^2
    dv := v * v * mkb;              // R           m.kg/s^2
    mdg := (dv - dm) / m;           // x         m/s^2
    fv := v - mdg * dt;             // \         m/s
    ndv := fv * fv * mkb;           // \R         m.kg/s^2
    nmdg := (ndv - dm) / m;         // \x       m/s^2
    mdg := (nmdg + mdg) / 2;        // ωx     m/s^2
    fv := v - mdg * dt;             //            m/s
    if fv < 0 then break;
    h := h + (fv + v) / 2 * dt;     //  + ϑx* m
    v := fv;                        // Vx               m/s
    kf := (m - v * v * k / g) / m;    // g̕ G@
    if i = j then begin
      hb := h;
      vb := v;
    end;
    if radiogroup1.ItemIndex = 3 then begin
      if maxmdg < mdg + kf * g then maxmdg := mdg + kf * g;
    end
    else
      if maxmdg < mdg then maxmdg := mdg;
    case radiogroup1.ItemIndex of
      0:  begin
            series1.AddXY(ti , -mdg / g);           // x G@
            series2.AddXY(ti , -h);                 //    m
          end;
      1:  begin
            series1.AddXY(ti , -mdg / g);           // x G@
            series2.AddXY(ti , -v);                 // x   m/s
          end;
      2:  begin
            series1.AddXY(ti , mkb);                // CRW  kg/m
            series2.AddXY(ti , -h);                 //   m
          end;
      3:  begin
            series1.AddXY(ti , -mdg /g - kf);      // x G@
            series2.AddXY(ti , -h);                 //   m
          end;
      4:  begin
            series1.AddXY(ti , -mdg / g);           // x G@
            if checkbox1.Checked = false then
              series2.AddXY(ti , sq * 100)           // pV[gJx
            else
              series2.AddXY(ti , sq * sq * 100);           // pV[gJx
          end;
    end;
  end;
  if fv < 0 then begin
    memo1.Lines.Append('VvZ sAԂ׌vZo܂B');
    exit;
  end;
  if checkbox1.Checked = true then
    memo1.Lines.Append('pV[g̊JxԂsinɔ')
  else
    memo1.Lines.Append('pV[g̊JxԂsinɔ');

  memo1.Lines.Append('tx ' + floatTostr(-vmax) + ' m/s');
  memo1.Lines.Append(floattostr(tB) + 'sec x ' + floatTostr(-vb) + ' m/s');
  memo1.Lines.Append(floattostr(tB) + 'sec  ' + floatTostr(-hb) + ' m');
  if radiogroup1.ItemIndex = 3 then
    memo1.Text := memo1.Text + 'CU[ő啉 ' + floatTostr(-maxmdg / g) + '@G'
  else
    memo1.Text := memo1.Text + 'őx ' + floatTostr(-maxmdg / g) + '@G';
end;

// vhvZs
procedure TForm1.vhBtnClick(Sender: TObject);
var
  k   : extended;   // CRW  kg/m
  kB  : extended;   // CRW  kg/m
  m   : extended;   //           kg
  tB   : extended;  //       sec
  g   : extended;   // d͉x    m/sec^2
  ch  : integer;
  j   : integer;
begin
  Memo1.Clear;
  val(kEdit.Text, k, ch);
  if ch <> 0 then begin
    Memo1.Text := 'k:CRWɊԈႢ܂B';
    exit;
  end;
  if k <= 0 then begin
    Memo1.Text := 'k:CRW̒l0([)傫ĂB';
    exit;
  end;
  val(k2Edit.Text, kB, ch);
  if ch <> 0 then begin
    Memo1.Text := 'kB:CRWɊԈႢ܂B';
    exit;
  end;
  if kB <= 0 then begin
    Memo1.Text := 'kB:CRW̒l0([)傫ĂB';
    exit;
  end;
  val(mEdit.Text, m, ch);
  if ch <> 0 then begin
    Memo1.Text := 'm:ʂɊԈႢ܂B';
    exit;
  end;
  if m <= 0 then begin
    Memo1.Text := 'm:ʂ̒l0([)傫ĂB';
    exit;
  end;
  val(tbEdit.Text, tB, ch);
  if ch <> 0 then begin
    Memo1.Text := 'tB:Reduce speed timeɊԈႢ܂B';
    exit;
  end;
  if tB < 0 then begin
    Memo1.Text := 'tB:Reduce speed time0([)傫ĂB';
    exit;
  end;
  val(gEdit.Text, g, ch);
  if ch <> 0 then begin
    Memo1.Text := 'g:xɊԈႢ܂B';
    exit;
  end;
  if g <= 0 then begin
    Memo1.Text := 'g:x̒l0([)傫ĂB';
    exit;
  end;
  val(jEdit.Text, j, ch);
  if ch <> 0 then begin
    Memo1.Text := 'j:ɊԈႢ܂B';
    exit;
  end;
  if j <= 2 then begin
    Memo1.Text := 'j:2傫ĂB';
    exit;
  end;
  if j > 10000000 then begin
    Memo1.Text := 'j:傫܂B';
    exit;
  end;
  memo1.Clear;
  downN(tB, k, kB, m, g, j);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  label1.Caption := ':Cx[kg/m^3]' + #13#10 + '@@̒lłB';
end;

end.
